package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.EnviosJson;
import com.ejie.ab79.model.InspeccionesJson;
import com.ejie.ab79.model.PreguntasJson;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * PreguntasJsonDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class PreguntasJsonDaoImpl implements PreguntasJsonDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDPREGUNTAJSON", "IDPREGUNTAPROTOCOLO",
			"IDPREGUNTAEXPEDIENTE", "IDPREGUNTAMOVIL", "ESTADO", "ERROR", "FECHAREGISTRO", "USUARIOREGISTRO",
			"FECHAULTMODIFICACION", "USUARIOULTMODIFICACION", "INSPECJSONINSPEC", "INSPECCIONESJSONIDINSPECCION",
			"INSPECJSONINSPECMOVIL", "INSPECCIONESJSONESTADO", "INSPECCIONESJSONERROR", "INSPECFECHAREGISTRO",
			"INSPECUSUARIOREGISTRO", "INSPECJSONFECULTMODIF", "INSPECUSUULTMODIF", "INSPECIDENVIOJSON" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<PreguntasJson> rwMap = new RowMapper<PreguntasJson>() {
		public PreguntasJson mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new PreguntasJson(resultSet.getInt("ID_PREGUNTA_JSON"), resultSet.getInt("ID_PREGUNTA_PROTOCOLO"),
					resultSet.getInt("ID_PREGUNTA_EXPEDIENTE"), resultSet.getString("ID_PREGUNTA_MOVIL"),
					resultSet.getInt("ESTADO"), resultSet.getString("ERROR"), resultSet.getDate("FECHA_REGISTRO"),
					resultSet.getString("USUARIO_REGISTRO"), resultSet.getDate("FECHA_ULTMODIFICACION"),
					resultSet.getString("USUARIO_ULTMODIFICACION"),
					new InspeccionesJson(resultSet.getInt("InspeccionesJsonID_INSPECCION_JSON"),
							resultSet.getInt("InspeccionesJsonID_INSPECCION"),
							resultSet.getString("InspeccionesJsonID_INSPECCION_MOVIL"),
							resultSet.getInt("InspeccionesJsonESTADO"), resultSet.getString("InspeccionesJsonERROR"),
							resultSet.getDate("InspeccionesJsonFECHA_REGISTRO"),
							resultSet.getString("InspeccionesJsonUSUARIO_REGISTRO"),
							resultSet.getDate("InspeccionesJsonFECHA_ULTMODIFICACION"),
							resultSet.getString("InspeccionesJsonUSUARIO_ULTMODIFICACION"),
							new EnviosJson(resultSet.getInt("InspeccionesJsonID_ENVIO_JSON"), null, null, null, null,
									null, null, null, null)));
		}
	};

	private RowMapper<PreguntasJson> rwMapPK = new RowMapper<PreguntasJson>() {
		public PreguntasJson mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new PreguntasJson(resultSet.getInt("ID_PREGUNTA_JSON"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<PreguntasJson>> rwMapJerarquia = new RowMapper<JerarquiaDto<PreguntasJson>>() {
		public JerarquiaDto<PreguntasJson> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			PreguntasJson preguntasjson = new PreguntasJson(resultSet.getInt("ID_PREGUNTA_JSON"),
					resultSet.getInt("ID_PREGUNTA_PROTOCOLO"), resultSet.getInt("ID_PREGUNTA_EXPEDIENTE"),
					resultSet.getString("ID_PREGUNTA_MOVIL"), resultSet.getInt("ESTADO"), resultSet.getString("ERROR"),
					resultSet.getDate("FECHA_REGISTRO"), resultSet.getString("USUARIO_REGISTRO"),
					resultSet.getDate("FECHA_ULTMODIFICACION"), resultSet.getString("USUARIO_ULTMODIFICACION"),
					new InspeccionesJson(resultSet.getInt("InspeccionesJsonID_INSPECCION_JSON"),
							resultSet.getInt("InspeccionesJsonID_INSPECCION"),
							resultSet.getString("InspeccionesJsonID_INSPECCION_MOVIL"),
							resultSet.getInt("InspeccionesJsonESTADO"), resultSet.getString("InspeccionesJsonERROR"),
							resultSet.getDate("InspeccionesJsonFECHA_REGISTRO"),
							resultSet.getString("InspeccionesJsonUSUARIO_REGISTRO"),
							resultSet.getDate("InspeccionesJsonFECHA_ULTMODIFICACION"),
							resultSet.getString("InspeccionesJsonUSUARIO_ULTMODIFICACION"),
							new EnviosJson(resultSet.getInt("InspeccionesJsonID_ENVIO_JSON"), null, null, null, null,
									null, null, null, null)));

			JerarquiaDto<PreguntasJson> jerarquia = new JerarquiaDto<PreguntasJson>();
			jerarquia.setModel(preguntasjson);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the PreguntasJson table.
	 *
	 * @param preguntasjson
	 *            PreguntasJson
	 * @return PreguntasJson
	 */
	@Transactional(propagation = Propagation.REQUIRES_NEW, rollbackFor = Exception.class)
	public PreguntasJson add(PreguntasJson preguntasjson) {
		int idPreguntasJson = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7936T00.NEXTVAL FROM DUAL",
				Integer.class);
		preguntasjson.setIdPreguntaJson(idPreguntasJson);
		String query = "INSERT INTO PREGUNTAS_JSON (ID_PREGUNTA_JSON, ID_INSPECCION_JSON, ID_PREGUNTA_PROTOCOLO, ID_PREGUNTA_EXPEDIENTE, ID_PREGUNTA_MOVIL, ESTADO, ERROR, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,?,?,SYSDATE,?)";
		Object getInspeccionesJsonIdInspeccionJsonAux = null;
		if (preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getIdInspeccionJson() != null) {
			getInspeccionesJsonIdInspeccionJsonAux = preguntasjson.getInspeccionesJson().getIdInspeccionJson();
		}
		this.jdbcTemplate.update(query, idPreguntasJson, getInspeccionesJsonIdInspeccionJsonAux,
				preguntasjson.getIdPreguntaProtocolo(), preguntasjson.getIdPreguntaExpediente(),
				preguntasjson.getIdPreguntaMovil(), preguntasjson.getEstado(), preguntasjson.getError(),
				preguntasjson.getUsuarioRegistro());
		return preguntasjson;
	}

	/**
	 * Updates a single row in the PreguntasJson table.
	 *
	 * @param preguntasjson
	 *            PreguntasJson
	 * @return PreguntasJson
	 */
	@Transactional(propagation = Propagation.REQUIRES_NEW, rollbackFor = Exception.class)
	public PreguntasJson update(PreguntasJson preguntasjson) {
		String query = "UPDATE PREGUNTAS_JSON SET ID_INSPECCION_JSON=?, ID_PREGUNTA_PROTOCOLO=?, ID_PREGUNTA_EXPEDIENTE=?, ID_PREGUNTA_MOVIL=?, ESTADO=?, ERROR=?, FECHA_ULTMODIFICACION=SYSDATE, USUARIO_ULTMODIFICACION=? WHERE ID_PREGUNTA_JSON=?";
		Object getInspeccionesJsonIdInspeccionJsonAux = null;
		if (preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getIdInspeccionJson() != null) {
			getInspeccionesJsonIdInspeccionJsonAux = preguntasjson.getInspeccionesJson().getIdInspeccionJson();
		}
		this.jdbcTemplate.update(query, getInspeccionesJsonIdInspeccionJsonAux, preguntasjson.getIdPreguntaProtocolo(),
				preguntasjson.getIdPreguntaExpediente(), preguntasjson.getIdPreguntaMovil(), preguntasjson.getEstado(),
				preguntasjson.getError(), preguntasjson.getUsuarioUltmodificacion(), preguntasjson.getIdPreguntaJson());
		return preguntasjson;
	}

	/**
	 * Finds a single row in the PreguntasJson table.
	 *
	 * @param preguntasjson
	 *            PreguntasJson
	 * @return PreguntasJson
	 */
	@Transactional(readOnly = true)
	public PreguntasJson find(PreguntasJson preguntasjson) {
		String query = "SELECT t1.ID_PREGUNTA_JSON IDPREGUNTAJSON, t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO, t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE, t1.ID_PREGUNTA_MOVIL IDPREGUNTAMOVIL, t1.ESTADO ESTADO, t1.ERROR ERROR, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t2.ID_INSPECCION_JSON INSPECJSONINSPEC, t2.ID_INSPECCION INSPECCIONESJSONIDINSPECCION, t2.ID_INSPECCION_MOVIL INSPECJSONINSPECMOVIL, t2.ESTADO INSPECCIONESJSONESTADO, t2.ERROR INSPECCIONESJSONERROR, t2.FECHA_REGISTRO INSPECFECHAREGISTRO, t2.USUARIO_REGISTRO INSPECUSUARIOREGISTRO, t2.FECHA_ULTMODIFICACION INSPECJSONFECULTMODIF, t2.USUARIO_ULTMODIFICACION INSPECUSUULTMODIF, t2.ID_ENVIO_JSON INSPECIDENVIOJSON FROM PREGUNTAS_JSON t1 , INSPECCIONES_JSON t2  WHERE t1.ID_PREGUNTA_JSON = ?   AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+)";

		List<PreguntasJson> preguntasjsonList = this.jdbcTemplate.query(query, this.rwMap,
				preguntasjson.getIdPreguntaJson());
		return (PreguntasJson) DataAccessUtils.uniqueResult(preguntasjsonList);
	}

	/**
	 * Removes a single row in the PreguntasJson table.
	 *
	 * @param preguntasjson
	 *            PreguntasJson
	 * @return
	 */
	public void remove(PreguntasJson preguntasjson) {
		String query = "DELETE FROM PREGUNTAS_JSON WHERE ID_PREGUNTA_JSON=?";
		this.jdbcTemplate.update(query, preguntasjson.getIdPreguntaJson());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<PreguntasJson> getMultiple(PreguntasJson filterPreguntasJson, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterPreguntasJson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, PreguntasJson.class, params,
				"ID_PREGUNTA_JSON");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the PreguntasJson table.
	 *
	 * @param preguntasjson
	 *            PreguntasJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<PreguntasJson>
	 */
	@Transactional(readOnly = true)
	public List<PreguntasJson> findAll(PreguntasJson preguntasjson, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PREGUNTA_JSON IDPREGUNTAJSON,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.ID_PREGUNTA_MOVIL IDPREGUNTAMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONINSPEC,t2.ID_INSPECCION INSPECCIONESJSONIDINSPECCION,t2.ID_INSPECCION_MOVIL INSPECJSONINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECUSUULTMODIF,t2.ID_ENVIO_JSON INSPECIDENVIOJSON ");
		query.append("FROM PREGUNTAS_JSON t1 ,INSPECCIONES_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(preguntasjson);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, PreguntasJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<PreguntasJson>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the PreguntasJson table using like.
	 *
	 * @param preguntasjson
	 *            PreguntasJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<PreguntasJson>
	 */
	@Transactional(readOnly = true)
	public List<PreguntasJson> findAllLike(PreguntasJson preguntasjson, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PREGUNTA_JSON IDPREGUNTAJSON,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.ID_PREGUNTA_MOVIL IDPREGUNTAMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONINSPEC,t2.ID_INSPECCION INSPECCIONESJSONIDINSPECCION,t2.ID_INSPECCION_MOVIL INSPECJSONINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECUSUULTMODIF,t2.ID_ENVIO_JSON INSPECIDENVIOJSON ");
		query.append("FROM PREGUNTAS_JSON t1 ,INSPECCIONES_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(preguntasjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, PreguntasJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<PreguntasJson>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the PreguntasJson table.
	 *
	 * @param preguntasjson
	 *            PreguntasJson
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(PreguntasJson preguntasjson) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM PREGUNTAS_JSON t1 , INSPECCIONES_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(preguntasjson);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the PreguntasJson table using like.
	 *
	 * @param preguntasjson
	 *            PreguntasJson
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(PreguntasJson preguntasjson, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM PREGUNTAS_JSON t1 ,INSPECCIONES_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(preguntasjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of PreguntasJson selected for rup_table
	 *
	 * @param preguntasjson
	 *            PreguntasJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PreguntasJson>>
	 */
	@Override
	public List<TableRowDto<PreguntasJson>> reorderSelection(PreguntasJson preguntasjson,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PREGUNTA_JSON IDPREGUNTAJSON,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.ID_PREGUNTA_MOVIL IDPREGUNTAMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONINSPEC,t2.ID_INSPECCION INSPECCIONESJSONIDINSPECCION,t2.ID_INSPECCION_MOVIL INSPECJSONINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECUSUULTMODIF,t2.ID_ENVIO_JSON INSPECIDENVIOJSON ");
		// FROM
		query.append("FROM PREGUNTAS_JSON t1 ,INSPECCIONES_JSON t2 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(preguntasjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, PreguntasJson.class,
				filterParamList, "ID_PREGUNTA_JSON");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<PreguntasJson>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            PreguntasJson
	 * @param searchParams
	 *            PreguntasJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<PreguntasJson>>
	 */
	@Override
	public List<TableRowDto<PreguntasJson>> search(PreguntasJson filterParams, PreguntasJson searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PREGUNTA_JSON IDPREGUNTAJSON,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.ID_PREGUNTA_MOVIL IDPREGUNTAMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONINSPEC,t2.ID_INSPECCION INSPECCIONESJSONIDINSPECCION,t2.ID_INSPECCION_MOVIL INSPECJSONINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECUSUULTMODIF,t2.ID_ENVIO_JSON INSPECIDENVIOJSON ");
		// FROM
		query.append("FROM PREGUNTAS_JSON t1 ,INSPECCIONES_JSON t2 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, PreguntasJson.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_PREGUNTA_JSON");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<PreguntasJson>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterpreguntasjson
	 *            PreguntasJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(PreguntasJson filterpreguntasjson, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PREGUNTA_JSON IDPREGUNTAJSON,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.ID_PREGUNTA_MOVIL IDPREGUNTAMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONINSPEC,t2.ID_INSPECCION INSPECCIONESJSONIDINSPECCION,t2.ID_INSPECCION_MOVIL INSPECJSONINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECUSUULTMODIF,t2.ID_ENVIO_JSON INSPECIDENVIOJSON ");
		// FROM
		query.append("FROM PREGUNTAS_JSON t1 ,INSPECCIONES_JSON t2 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterpreguntasjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, PreguntasJson.class,
				query, params, "ID_PREGUNTA_JSON");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical PreguntasJson table.
	 *
	 * @param filterPreguntasJson
	 *            PreguntasJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<PreguntasJson>>
	 */
	@Override
	public List<JerarquiaDto<PreguntasJson>> findAllLikeJerarquia(PreguntasJson filterPreguntasJson,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PREGUNTA_JSON IDPREGUNTAJSON,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.ID_PREGUNTA_MOVIL IDPREGUNTAMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONINSPEC,t2.ID_INSPECCION INSPECCIONESJSONIDINSPECCION,t2.ID_INSPECCION_MOVIL INSPECJSONINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECUSUULTMODIF,t2.ID_ENVIO_JSON INSPECIDENVIOJSON ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM PREGUNTAS_JSON t1
		// ,INSPECCIONES_JSON t2 ");
		List<String> from = new ArrayList<String>();
		from.add("PREGUNTAS_JSON");
		from.add("INSPECCIONES_JSON");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterPreguntasJson, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_PREGUNTA_JSON", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					PreguntasJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterPreguntasJson
	 *            PreguntasJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(PreguntasJson filterPreguntasJson, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM PREGUNTAS_JSON t1
		// ,INSPECCIONES_JSON t2 ");
		List<String> from = new ArrayList<String>();
		from.add("PREGUNTAS_JSON");
		from.add("INSPECCIONES_JSON");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterPreguntasJson, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_PREGUNTA_JSON",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterPreguntasJson
	 *            PreguntasJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<PreguntasJson>>
	 */
	@Override
	public List<TableRowDto<PreguntasJson>> findAllChild(PreguntasJson filterPreguntasJson,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM PREGUNTAS_JSON t1
		// ,INSPECCIONES_JSON t2 ");
		List<String> from = new ArrayList<String>();
		from.add("PREGUNTAS_JSON");
		from.add("INSPECCIONES_JSON");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterPreguntasJson, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_PREGUNTA_JSON",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<PreguntasJson>(this.rwMapPK, "ID_PREGUNTA_JSON"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the PreguntasJson entity
	 *
	 * @param preguntasjson
	 *            PreguntasJson Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(PreguntasJson preguntasjson) {

		StringBuilder where = new StringBuilder(PreguntasJsonDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (preguntasjson != null && preguntasjson.getIdPreguntaJson() != null) {
			where.append(" AND t1.ID_PREGUNTA_JSON = ?");
			params.add(preguntasjson.getIdPreguntaJson());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getIdInspeccionJson() != null) {
			where.append(" AND t2.ID_INSPECCION_JSON = ?");
			params.add(preguntasjson.getInspeccionesJson().getIdInspeccionJson());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getEnviosJson() != null
				&& preguntasjson.getInspeccionesJson().getEnviosJson().getIdEnvioJson() != null) {
			where.append(" AND t2.ID_ENVIO_JSON = ?");
			params.add(preguntasjson.getInspeccionesJson().getEnviosJson().getIdEnvioJson());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getIdInspeccion() != null) {
			where.append(" AND t2.ID_INSPECCION = ?");
			params.add(preguntasjson.getInspeccionesJson().getIdInspeccion());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getIdInspeccionMovil() != null) {
			where.append(" AND t2.ID_INSPECCION_MOVIL = ?");
			params.add(preguntasjson.getInspeccionesJson().getIdInspeccionMovil());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getEstado() != null) {
			where.append(" AND t2.ESTADO = ?");
			params.add(preguntasjson.getInspeccionesJson().getEstado());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getError() != null) {
			where.append(" AND t2.ERROR = ?");
			params.add(preguntasjson.getInspeccionesJson().getError());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getFechaRegistro() != null) {
			where.append(" AND t2.FECHA_REGISTRO = ?");
			params.add(preguntasjson.getInspeccionesJson().getFechaRegistro());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getUsuarioRegistro() != null) {
			where.append(" AND t2.USUARIO_REGISTRO = ?");
			params.add(preguntasjson.getInspeccionesJson().getUsuarioRegistro());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getFechaUltmodificacion() != null) {
			where.append(" AND t2.FECHA_ULTMODIFICACION = ?");
			params.add(preguntasjson.getInspeccionesJson().getFechaUltmodificacion());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getUsuarioUltmodificacion() != null) {
			where.append(" AND t2.USUARIO_ULTMODIFICACION = ?");
			params.add(preguntasjson.getInspeccionesJson().getUsuarioUltmodificacion());
		}
		if (preguntasjson != null && preguntasjson.getIdPreguntaProtocolo() != null) {
			where.append(" AND t1.ID_PREGUNTA_PROTOCOLO = ?");
			params.add(preguntasjson.getIdPreguntaProtocolo());
		}
		if (preguntasjson != null && preguntasjson.getIdPreguntaExpediente() != null) {
			where.append(" AND t1.ID_PREGUNTA_EXPEDIENTE = ?");
			params.add(preguntasjson.getIdPreguntaExpediente());
		}
		if (preguntasjson != null && preguntasjson.getIdPreguntaMovil() != null) {
			where.append(" AND t1.ID_PREGUNTA_MOVIL = ?");
			params.add(preguntasjson.getIdPreguntaMovil());
		}
		if (preguntasjson != null && preguntasjson.getEstado() != null) {
			where.append(" AND t1.ESTADO = ?");
			params.add(preguntasjson.getEstado());
		}
		if (preguntasjson != null && preguntasjson.getError() != null) {
			where.append(" AND t1.ERROR = ?");
			params.add(preguntasjson.getError());
		}
		if (preguntasjson != null && preguntasjson.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(preguntasjson.getFechaRegistro());
		}
		if (preguntasjson != null && preguntasjson.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(preguntasjson.getUsuarioRegistro());
		}
		if (preguntasjson != null && preguntasjson.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(preguntasjson.getFechaUltmodificacion());
		}
		if (preguntasjson != null && preguntasjson.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(preguntasjson.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the PreguntasJson entity
	 *
	 * @param preguntasjson
	 *            PreguntasJson Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(PreguntasJson preguntasjson, Boolean startsWith) {

		StringBuilder where = new StringBuilder(PreguntasJsonDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (preguntasjson != null && preguntasjson.getIdPreguntaJson() != null) {
			where.append(" AND t1.ID_PREGUNTA_JSON = ?");
			params.add(preguntasjson.getIdPreguntaJson());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getIdInspeccionJson() != null) {
			where.append(" AND t2.ID_INSPECCION_JSON = ?");
			params.add(preguntasjson.getInspeccionesJson().getIdInspeccionJson());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getEnviosJson() != null
				&& preguntasjson.getInspeccionesJson().getEnviosJson().getIdEnvioJson() != null) {
			where.append(" AND t2.ID_ENVIO_JSON = ?");
			params.add(preguntasjson.getInspeccionesJson().getEnviosJson().getIdEnvioJson());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getIdInspeccion() != null) {
			where.append(" AND t2.ID_INSPECCION = ?");
			params.add(preguntasjson.getInspeccionesJson().getIdInspeccion());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getIdInspeccionMovil() != null) {
			where.append(" AND UPPER(t2.ID_INSPECCION_MOVIL) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(preguntasjson.getInspeccionesJson().getIdInspeccionMovil().toUpperCase() + "%");
			} else {
				params.add("%" + preguntasjson.getInspeccionesJson().getIdInspeccionMovil().toUpperCase() + "%");
			}
			where.append(" AND t2.ID_INSPECCION_MOVIL IS NOT NULL");
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getEstado() != null) {
			where.append(" AND t2.ESTADO = ?");
			params.add(preguntasjson.getInspeccionesJson().getEstado());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getError() != null) {
			where.append(" AND UPPER(t2.ERROR) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(preguntasjson.getInspeccionesJson().getError().toUpperCase() + "%");
			} else {
				params.add("%" + preguntasjson.getInspeccionesJson().getError().toUpperCase() + "%");
			}
			where.append(" AND t2.ERROR IS NOT NULL");
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getFechaRegistro() != null) {
			where.append(" AND t2.FECHA_REGISTRO = ?");
			params.add(preguntasjson.getInspeccionesJson().getFechaRegistro());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t2.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(preguntasjson.getInspeccionesJson().getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + preguntasjson.getInspeccionesJson().getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t2.USUARIO_REGISTRO IS NOT NULL");
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getFechaUltmodificacion() != null) {
			where.append(" AND t2.FECHA_ULTMODIFICACION = ?");
			params.add(preguntasjson.getInspeccionesJson().getFechaUltmodificacion());
		}
		if (preguntasjson != null && preguntasjson.getInspeccionesJson() != null
				&& preguntasjson.getInspeccionesJson().getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t2.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(preguntasjson.getInspeccionesJson().getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + preguntasjson.getInspeccionesJson().getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t2.USUARIO_ULTMODIFICACION IS NOT NULL");
		}
		if (preguntasjson != null && preguntasjson.getIdPreguntaProtocolo() != null) {
			where.append(" AND t1.ID_PREGUNTA_PROTOCOLO = ?");
			params.add(preguntasjson.getIdPreguntaProtocolo());
		}
		if (preguntasjson != null && preguntasjson.getIdPreguntaExpediente() != null) {
			where.append(" AND t1.ID_PREGUNTA_EXPEDIENTE = ?");
			params.add(preguntasjson.getIdPreguntaExpediente());
		}
		if (preguntasjson != null && preguntasjson.getIdPreguntaMovil() != null) {
			where.append(" AND UPPER(t1.ID_PREGUNTA_MOVIL) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(preguntasjson.getIdPreguntaMovil().toUpperCase() + "%");
			} else {
				params.add("%" + preguntasjson.getIdPreguntaMovil().toUpperCase() + "%");
			}
			where.append(" AND t1.ID_PREGUNTA_MOVIL IS NOT NULL");
		}
		if (preguntasjson != null && preguntasjson.getEstado() != null) {
			where.append(" AND t1.ESTADO = ?");
			params.add(preguntasjson.getEstado());
		}
		if (preguntasjson != null && preguntasjson.getError() != null) {
			where.append(" AND UPPER(t1.ERROR) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(preguntasjson.getError().toUpperCase() + "%");
			} else {
				params.add("%" + preguntasjson.getError().toUpperCase() + "%");
			}
			where.append(" AND t1.ERROR IS NOT NULL");
		}
		if (preguntasjson != null && preguntasjson.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(preguntasjson.getFechaRegistro());
		}
		if (preguntasjson != null && preguntasjson.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(preguntasjson.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + preguntasjson.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (preguntasjson != null && preguntasjson.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(preguntasjson.getFechaUltmodificacion());
		}
		if (preguntasjson != null && preguntasjson.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(preguntasjson.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + preguntasjson.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
